/* $Id$ */
package saccubus.worker.classic.profile;

import saccubus.worker.profile.CommentProfile;
import saccubus.worker.profile.VideoProfile;

/**
 * Converterに処理させるための設定.
 * @author yuki
 */
public class Profile implements saccubus.worker.profile.DownloadProfile {

    private final GeneralSetting generalSetting;
    private final LoginInfo loginInfo;
    private final VideoProfile videoSetting;
    private final CommentProfile commentSetting;
    private final CommentGetInfo commentGetInfo;
    private final InputFileSetting tcommentSetting;
    private final OutputFileSetting outputFileSetting;
    private final Ffmpeg ffmpeg;

    public Profile(
            GeneralSetting generalSetting,
            LoginInfo loginInfo,
            VideoProfile videoSetting,
            CommentProfile commentSetting,
            CommentGetInfo commentGetInfo,
            InputFileSetting tcommentSetting,
            OutputFileSetting outputFileSetting,
            Ffmpeg ffmpeg) {
        this.generalSetting = generalSetting;
        this.loginInfo = loginInfo;
        this.videoSetting = videoSetting;
        this.commentSetting = commentSetting;
        this.commentGetInfo = commentGetInfo;
        this.tcommentSetting = tcommentSetting;
        this.outputFileSetting = outputFileSetting;
        this.ffmpeg = ffmpeg;
    }

    @Override
    public LoginInfo getLoginInfo() {
        return loginInfo;
    }

    @Override
    public Proxy getProxyProfile(){
        return loginInfo.getProxy();
    }

    @Override
    public VideoProfile getVideoProfile() {
        return videoSetting;
    }

    @Override
    public CommentProfile getCommentProfile() {
        return commentSetting;
    }

    public InputFileSetting getTcommentSetting() {
        return tcommentSetting;
    }

    public OutputFileSetting getOutputFileSetting() {
        return outputFileSetting;
    }

    public CommentGetInfo getCommentGetInfo() {
        return commentGetInfo;
    }

    public boolean needsConvert() {
        return getOutputFileSetting().isConvert();
    }

    @Override
    public GeneralSetting getGeneralProfile() {
        return generalSetting;
    }
}
